create database  mrt with log;

create table Customer (
	CustId          integer       not null ,
	CustName        varchar(50,0) not null ,
	Region          varchar(25,0) not null ,        
	Address1        varchar(50,0) not null ,
	Address2        varchar(50,0) ,
	City            varchar(50,0) not null ,
	State           varchar(25,0) not null ,
	Zip             varchar(11,0) not null ,
	Phone           varchar(25,0) not null ,
	Fax             varchar(25,0) not null ,
	Email           varchar(25,0) not null ,
	CustGroupId     integer       not null ,
	LeadID          integer       not null  
);


create table CustomerGroup (
	CustGroupId     integer       not null ,
	CustGroupName   varchar(25,0) not null ,
	CustGroupDesc   varchar(25,0) not null 
);


create table Product (
	ProdID          integer         not null,
	ProdName        varchar(50,0)   not null,
	ProdDesc        text            not null, 
	ProdGroupID     integer         not null
);


create table ProductGroup (
	ProdGroupID     integer         not null,
	GroupName       varchar(25,0)   not null,
	GroupDesc       varchar(25,0)   not null 
);


create table SalesInformation (
	CustID          integer,
	ProdID          integer,
	Year            integer,
	Month           integer,
	CurrentSales    decimal(10,2),
	PriorSales      decimal(10,2),
	PlanSales       decimal(10,2)
);


create table LeadSources (
	LeadID          integer,
	LeadName        varchar(25,0),
	LeadDesc        varchar(25,0)
);


create table MonthReference (
	Month           integer,
	MonthName       varchar(25,0)
);

create table Custom_Reports (
	Name            varchar (25,0)  not null,
	Category        varchar (25,0)  not null,
	Query           text            not null
);


CREATE DBA PROCEDURE MATCHES(
        i_First  INTEGER,
        i_Second INTEGER,
        d_True   DECIMAL(10,2),
        d_False  DECIMAL(10,2)
)

   RETURNING DECIMAL(10,2);

DEFINE d_RetVal DECIMAL(10,2);

IF (i_First = i_Second) THEN
     let d_RetVal = d_True;
ELSE
     let d_RetVal= d_False;
END IF;

RETURN d_RetVal;

END PROCEDURE

Grant resource to public;


