/*
    Neil's Barcharting Software...
    V II


 */
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.io.*;
import java.lang.*;
import java.net.URL;


public class Chart extends java.applet.Applet {

	Font		BarFont;
	FontMetrics	BarFontMetrics;

	float       BarWidth = 0.0f ;
	float       BarScale = 10.0f;
	boolean     BarsNotLines ;  // This is a bar/line chart...
	int         BarDepth = 3;
	int         BarSpace = 4;
    int         NumSubBars = 1;
    boolean     BarsHaveMates = false;
	float 		Max_Y = 0.0f;
	float 		Min_Y = 0.0f;   // Yes, this is ok at 0.00
	int		    NumBars = 0;

	String		x[] = new String[255];
	float		y[] = new float[255];
	float		z[] = new float[255];

    int         ScreenHeight;
    int         ScreenWidth;
    int         ScreenZero;
    int         ScreenTop, ScreenLeft;
    float       Max_Inc = 10.0f;
    float       Min_Inc = 10.0f;
    float       True_Max;
    float       True_Min;

public synchronized void init() {

	String p;

     // Setup our working font...
    //
    BarFont = new java.awt.Font("Arial",Font.PLAIN,10);
    BarFontMetrics = getFontMetrics(BarFont);

     // Do we have paired bargraphs? (Check for z value...)
    //
    BarsHaveMates = (getParameter("z1") != null);

     // Is this a Bar or Line graph...
    //
    p = getParameter("type");
    p = (p == null) ? "BAR" : p;
    BarsNotLines = !(p.equalsIgnoreCase("LINE"));


     // Read in all the bars
    //
	while ( (p = getParameter("x" + (NumBars+1))) != null ) {

		x[NumBars] = (p == null) ? "" : p;

		p = getParameter( "y" + (NumBars+1) );
		p = (p == null) ? "0.00" : p;
        y[NumBars] = Float.valueOf(p).floatValue();

        if (BarsHaveMates) {

		    p = getParameter( "z" + (NumBars+1) );
    		p = (p == null) ? "0.00" : p;
            z[NumBars] = Float.valueOf(p).floatValue();

            Max_Y = Math.max(z[NumBars],Max_Y);
       	    Min_Y = Math.min(z[NumBars],Min_Y);

        }

        Max_Y = Math.max(y[NumBars],Max_Y);
   	    Min_Y = Math.min(y[NumBars],Min_Y);

		NumBars ++;
	}

    while ((Max_Y/Max_Inc) > 10){
      Max_Inc=Max_Inc*10;
    }

    True_Max = 0.0f;

    while (Max_Y > True_Max){
        True_Max = True_Max + Max_Inc;
    }
  //  Max_Y = True_Max;

    while ((Math.abs(Min_Y)/Min_Inc) > 10){
      Min_Inc=Min_Inc*10;
    }

    True_Min = 0.0f;

    while (Min_Y < True_Min){
        True_Min = True_Min - Min_Inc;
    }
 //   Min_Y = True_Min;

 }


private void ShowLine(Graphics g, int Num, String x, float y, float z, float yNext, float zNext) {

    int x0 = (int)(BarWidth * Num) + (int)(BarWidth/2) + ScreenLeft;
    int x1 = x0 + (int)BarWidth;
    int y0,y1;
    int z0,z1;
    int b = ScreenTop + ScreenHeight;


    if (Num < NumBars - 1) {

        y0  = ScreenZero - (int)(BarScale * y);
        y1  = ScreenZero - (int)(BarScale * yNext);
        g.setColor(Color.gray);
      	g.drawLine( x0 + BarDepth, y0 - BarDepth, x1 + BarDepth,y1 - BarDepth);
        g.setColor(Color.blue);
      	g.drawLine( x0, y0, x1,y1);

        if (BarsHaveMates) {
            z0  = ScreenZero - (int)(BarScale * z);
            z1  = ScreenZero - (int)(BarScale * zNext);
            g.setColor(Color.gray);
          	g.drawLine( x0 + BarDepth, z0 - BarDepth, x1 + BarDepth,z1 - BarDepth);
            g.setColor(Color.cyan);
          	g.drawLine( x0, z0, x1,z1);
        }

    }

    // Draw tick & string
  	g.setColor(Color.black);
  	g.drawLine(x0,b,x0,b+3);
   	g.drawString(x,x0-(int)(BarFontMetrics.stringWidth(x)/2),b + 2 + BarFontMetrics.getHeight());


}





private void ShowBar(Graphics g, int Num, String x, float y, float z) {

    int w;
    int x1 = (int)(BarWidth * Num) + ScreenLeft;
    int m  = (int)(x1 + (BarWidth / 2));
    int b = ScreenTop + ScreenHeight;

    int h1,y1;
    int h2,y2;


    if (BarsHaveMates)
        w  = ((int)BarWidth - BarDepth - BarSpace) / 2;
    else
        w  = (int)BarWidth - BarDepth - BarSpace;

    if (y < 0.00) {
        y1 = ScreenZero;
        h1  = (int)(-y * BarScale); }
    else {
        h1  = (int)(y * BarScale);
        y1 = (ScreenZero - h1);
    }

    if (BarsHaveMates) {

        if (z < 0.00) {
            y2 = ScreenZero;
            h2  = (int)(-z * BarScale); }
        else {
            h2  = (int)(z * BarScale);
            y2 = (ScreenZero - h2);
        }


        // Cyan Bar and Shadow
        g.setColor(Color.gray);
     	g.fillRect( x1 + BarDepth+(int)(BarWidth / 2), y2 - BarDepth, w,h2);
        g.setColor(Color.cyan);
     	g.fillRect( x1+(int)(BarWidth / 2), y2, w,h2);

        // Blue Bar and Shadow
        g.setColor(Color.gray);
     	g.fillRect( x1 + BarDepth, y1 - BarDepth, w,h1);
        g.setColor(Color.blue);
     	g.fillRect( x1, y1, w,h1);

    }
    else {

        // Blue Bar and Shadow
        g.setColor(Color.gray);
     	g.fillRect( x1 + BarDepth, y1 - BarDepth, w,h1);
        g.setColor(Color.blue);
     	g.fillRect( x1, y1, w,h1);

    }

    // Draw tick & string
  	g.setColor(Color.black);
  	g.drawLine(m,b,m,b+3);
   	g.drawString(x,m-(int)(BarFontMetrics.stringWidth(x)/2),b + 2 + BarFontMetrics.getHeight());


}

public String f2String(float z) {

    String s;
    String r;
    int i;

    s = String.valueOf(z);
    i = s.indexOf('.');

    if (i < 0) {
        r = s + ".00"; }
    else {
        s += "00";
        r = s.substring(0,i+3);
    }

    return (r);

}


public synchronized void paint(Graphics g) {

	int i, j;
	int BarHeight;
	int Bottom = size().height;
	int sx,sy;
	String t,l;
	int Last_Tick=0;
	int Inc=0;
    int TestStr=0;


     // Init Scaling vars
    //
    ScreenTop    = BarDepth + 10;
    ScreenLeft   = BarFontMetrics.stringWidth(f2String(True_Max)) + 13;
    ScreenHeight = size().height - 17 - BarFontMetrics.getHeight();
    ScreenWidth  = size().width - ScreenLeft - BarDepth - 5;
    ScreenZero   = ScreenTop + (int)( (True_Max/(True_Max - True_Min)) * (float)ScreenHeight) ;

    g.setColor(new Color(245, 245, 235));
    g.fillRect(0, 0, size().width, size().height);

	BarWidth = ((float)ScreenWidth / (float)NumBars);
	BarScale = ( ((float)ScreenHeight) / (True_Max - True_Min));

      // Draw labels & Grid...
    //
    sx = ScreenLeft;
    sy = ScreenTop ;

    if (True_Max==0){
        Inc = Math.abs((int)(True_Min/4.0f));
        TestStr=1;
    }
    else if (True_Min==0){
        Inc = (int)(True_Max/4.0f);
                        TestStr=2;
    }
    else if (Math.abs(True_Max) >= Math.abs(True_Min)){
        Inc = (int)(True_Max/2.0f);
                        TestStr=3;
    }
    else if (Math.abs(True_Max) < Math.abs(True_Min)){
        Inc = Math.abs((int)(True_Min/2.0f));
                        TestStr=4;
    }

    /*while (Last_Tick > True_Min){
       g.setColor(Color.black);
       l = String.valueOf(Last_Tick);
       g.drawString(l,sx - BarFontMetrics.stringWidth( l )- 10,sy);

       g.setColor(Color.gray);
       g.drawLine(sx,sy,sx+ScreenWidth,sy);
       sy += (int)( (Inc/(True_Max - True_Min)) * (float)ScreenHeight) ;
       Last_Tick -= Inc;
    }*/
    sy=ScreenZero +  (int)( (Inc/(True_Max - True_Min)) * (float)ScreenHeight);
    Last_Tick -= Inc;
    while (Last_Tick >= True_Min){
       g.setColor(Color.black);
       l = String.valueOf(Last_Tick)+"%";
       g.drawString(l,sx - BarFontMetrics.stringWidth( l )- 10,sy);

       g.setColor(Color.gray);
       g.drawLine(sx,sy,sx+ScreenWidth,sy);
       sy += (int)( (Inc/(True_Max - True_Min)) * (float)ScreenHeight) ;
       Last_Tick -= Inc;
    }
    sy=ScreenZero -  (int)( (Inc/(True_Max - True_Min)) * (float)ScreenHeight);
    Last_Tick=0;
    Last_Tick += Inc;
    while (Last_Tick <= True_Max){
       g.setColor(Color.black);
       l = String.valueOf(Last_Tick)+"%";
       g.drawString(l,sx - BarFontMetrics.stringWidth( l )- 10,sy);

       g.setColor(Color.gray);
       g.drawLine(sx,sy,sx+ScreenWidth,sy);
       sy -= (int)( (Inc/(True_Max - True_Min)) * (float)ScreenHeight) ;
       Last_Tick += Inc;
    }



     // Draw 0.00 !
    //
    g.setColor(Color.red);
    g.drawLine(sx,ScreenZero,sx+ScreenWidth,ScreenZero);
    g.setColor(Color.red);
    g.drawString("0%",sx - BarFontMetrics.stringWidth("0.00")- 10,ScreenZero);

      // Draw Screen
    //
    g.setColor(Color.black);
    g.drawRect(ScreenLeft, ScreenTop,ScreenWidth,ScreenHeight);



	if (BarsNotLines) {
    	for (i=0; i < NumBars; i++)
            ShowBar(g,i,x[i],y[i], z[i]); }
    else {
    	for (i=0; i < NumBars; i++)
            ShowLine(g,i,x[i],y[i], z[i],y[i+1], z[i+1]);
   	}




}

}  // End of Main Class...